import axios from 'axios'
import Head from 'next/head'
import Image from 'next/image'
import Header from '../components/Header'
import Nav from '../components/Nav'
import ArticleFeed from '../components/ArticleFeed'
import { useState } from 'react'
import api from '../services/token-interceptors'
import  { useRouter } from 'next/router'
import Banner from '../components/Banner'
import Footer from '../components/Footer'

export default function Home({articles, categories}) {
  const [posts, setPost] = useState(articles);
  const router = useRouter();

  async function deleteArticle(id){
    await api.delete(process.env.NEXT_PUBLIC_SERVER_URL + '/api/article/' +id);
    setPost(
        posts.filter(item => item.id !== id)
    )
    refreshData()
}


const refreshData = () => {
  router.replace(router.asPath);
}


  return (
    <div>
      <Head>
        <title>Create Next App</title>
        <meta name="description" content="Generated by create next app" />
        <link rel="icon" href="/favicon.ico" />
      </Head>

     <Header/>
     <Nav categories={categories}/>
    <Banner/>
     <ArticleFeed articles={articles} onDelete={deleteArticle} />
     <Footer/>

    </div>
  )
}

export async function getServerSideProps(){
  const response = await axios.get(process.env.NEXT_PUBLIC_SERVER_URL + "/api/article");
  const resp = await axios.get(process.env.NEXT_PUBLIC_SERVER_URL + "/api/category");

  return {
      props: {
          articles: response.data,
          categories: resp.data
      }
  }
}